<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 26/10/2015
 * Time: 16:44
 */

namespace Service\Hcm;

use Repositories\ContabilRepository;

class ContabilService {

    private $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager,
                                ContabilRepository $contabilRepository)
    {
        $this->entityManager = $entityManager;
        $this->contabilRepository = $contabilRepository;
    }

    public function getResumosByDtocorrenciaAndNrorg($dtocorrencia, $nrorg)
    {
        try {
            $query = <<<SQL
SELECT
    RC.NRRESUMOCTBL,
    RC.NRLANCAMENTO,
    RC.IDTIPOLANC,
    RC.DTULTATU,
    RC.NRESTRUTURAM,
    RC.NRESTRUTURAMSUP,
    EM.CDINTESTRUTEXP,
    EM.CDINTESTRUTEXPFIL,
    RC.CDCONTCTBL,
    CCT.NMCONTCTBL,
    RC.CDHISTPADR,
    HP.DSHISTPADR,
    RC.VRLANCAMENTO
  FROM FPA_RESUMOCTBL RC
  LEFT JOIN HISTPADR HP ON HP.NRORG      = RC.NRORG
                       AND HP.CDHISTPADR = RC.CDHISTPADR
  LEFT JOIN CONTCTBL CCT ON CCT.NRORG      = RC.NRORG
                        AND CCT.CDCONTCTBL = RC.CDCONTCTBL
                        --AND CCT.IDTIPOCOME = 'B' --Somente tipo 'banco'
  LEFT JOIN ESTRUTURAM EM ON EM.NRORG        = RC.NRORG
                         AND EM.NRESTRUTURAM = RC.NRESTRUTURAM
 WHERE RC.NRORG        = :P_NRORG
   AND RC.DTOCORRENCIA = '$dtocorrencia'
 ORDER BY 1
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_DTOCORRENCIA' => $dtocorrencia
            );

            $resumos = $this->entityManager->getConnection()->fetchAll($query, $params);

            return $resumos;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getResumosDroByCnpjSupAndDtocorrenciaAndNrorg($nrorg, $cdfilial, $dtocorrencia, $nrtipomoviment)
    {
        return $this->contabilRepository->getResumosDroByCnpjSupAndDtocorrenciaAndNrorg($nrorg, $cdfilial, $dtocorrencia, $nrtipomoviment);
    }
}