IF EXISTS(SELECT NAME FROM SYSOBJECTS 
           WHERE NAME = 'ATUALIZA_SALDO_GERAL'
             AND TYPE = 'P')
  DROP PROCEDURE ATUALIZA_SALDO_GERAL
GO

CREATE PROCEDURE ATUALIZA_SALDO_GERAL(
  @P_CDEMPRESA  VARCHAR(02),
  @P_DATAINIC   DATETIME)
AS
  DECLARE @V_CDCONTINI   VARCHAR(20);
  DECLARE @V_CDCONTFIM   VARCHAR(20);
  DECLARE @V_DTFINACONT  DATETIME;
  DECLARE @DATA_SALDO    DATETIME;
  DECLARE @V_CONTSALDO   CHAR;
  DECLARE @V_IDSALDEMPR  CHAR;
  DECLARE @V_VERSAO      VARCHAR(1);
  DECLARE @V_VRSALDO     DOUBLE PRECISION;
  DECLARE @V_VRSALDEMPR  DOUBLE PRECISION;
  DECLARE @V_MENOR_DATA  DATETIME;
  DECLARE @V_DATA_SALDO  DATETIME;




  /* VARIAVEIS DO CURSOR C_SALDANT */
  DECLARE @C_SALDANT_CDCONTCTBL    VARCHAR(20);
  DECLARE @C_SALDANT_DTSALDEMPR    DATETIME;
  DECLARE @C_SALDANT_VRSALDEMPR    DOUBLE PRECISION;

  /* VARIAVEIS DO CURSOR C_ATUALIZA */
  DECLARE @C_ATUALIZA_CDCONTCTBL   VARCHAR(20);
  DECLARE @C_ATUALIZA_MENOR_DATA   DATETIME;

  /* VARIAVEIS DO CURSOR C_SOMACONTA */
  DECLARE @C_SOMACONTA_CDCONTCTBL  VARCHAR(20);
  DECLARE @C_SOMACONTA_VALORSALDO  DOUBLE PRECISION;


  /* VARIAVEIS DO CURSOR C_SALDO */
  DECLARE @C_SALDO_CDCONTCTBL VARCHAR(20);
  DECLARE @C_SALDO_DTLANCCONT DATETIME;

  /*VARIAVEIS DO CURSOR C_ATUALIZA */
  DECLARE @C_ATUALIZAT_CDCONTCTBL   VARCHAR(20);
  DECLARE @C_ATUALIZAT_DTLANCCONT   DATETIME;

  /* VARIAVEIS DO CURSOR C_SALDO_SINTETICO */
  DECLARE @C_SALDO_SINTETICO_VRSALDOTRANSF DOUBLE PRECISION;
  DECLARE @C_SALDO_SINTETICO_DTSALDOTRANSF DATETIME;
  DECLARE @C_SALDO_SINTETICO_CDCONTCTBL    VARCHAR(20);

BEGIN
  SELECT @V_DTFINACONT = MAX(DTFINACONT),
         @V_IDSALDEMPR = MAX(IDSALDEMPR)
    FROM CONTOPECTBL
   WHERE CDEMPRESA = @P_CDEMPRESA;

  SELECT @V_CDCONTFIM = MAX(CDCONTCTBL)
    FROM CONTCTBL
   WHERE (IDCONTCCUS <> 'R');

  SELECT @V_CDCONTINI = MIN(CDCONTCTBL)
    FROM CONTCTBL
   WHERE (IDCONTCCUS <> 'R');

  DELETE FROM SALDEMPR
   WHERE (SALDEMPR.CDEMPRESA  =  @P_CDEMPRESA)
     AND (SALDEMPR.DTSALDEMPR >= @P_DATAINIC)
     AND (SALDEMPR.CDCONTCTBL IN (SELECT CDCONTCTBL
                                    FROM CONTCTBL
                                   WHERE (CDCONTCTBL BETWEEN @V_CDCONTINI AND @V_CDCONTFIM)
                                     AND (IDCONTCCUS <> 'R')));
  DELETE FROM SALDOTRANSF
   WHERE (SALDOTRANSF.CDEMPRESA      = @P_CDEMPRESA)
     AND (SALDOTRANSF.DTSALDOTRANSF >= @P_DATAINIC)
     AND (SALDOTRANSF.CDCONTCTBL IN (SELECT CDCONTCTBL
                                       FROM CONTCTBL
                                      WHERE (CDCONTCTBL BETWEEN @V_CDCONTINI AND @V_CDCONTFIM)
                                        AND (IDCONTCCUS <> 'R')));

  /*ATUALIZA SALDO ANTERIOR */

  DECLARE C_SALDANT CURSOR FOR
     SELECT SALDEMPR.CDCONTCTBL, SALDEMPR.DTSALDEMPR, SALDEMPR.VRSALDEMPR
       FROM SALDEMPR, CONTCTBL
      WHERE (SALDEMPR.CDEMPRESA  = @P_CDEMPRESA)
        AND (SALDEMPR.CDCONTCTBL BETWEEN @V_CDCONTINI AND @V_CDCONTFIM)
        AND (SALDEMPR.CDCONTCTBL = CONTCTBL.CDCONTCTBL)
        AND (CONTCTBL.IDCONTCCUS <> 'R')
        AND (SALDEMPR.DTSALDEMPR IN (SELECT MAX(S.DTSALDEMPR)
                                       FROM SALDEMPR S
                                      WHERE S.CDCONTCTBL = SALDEMPR.CDCONTCTBL
                                        AND S.CDEMPRESA  = @P_CDEMPRESA
                                        AND S.DTSALDEMPR < @P_DATAINIC));

  OPEN C_SALDANT;
  FETCH NEXT FROM C_SALDANT INTO @C_SALDANT_CDCONTCTBL, @C_SALDANT_DTSALDEMPR, @C_SALDANT_VRSALDEMPR;

  WHILE (@@FETCH_STATUS = 0) BEGIN

     SET @DATA_SALDO = @C_SALDANT_DTSALDEMPR;

	  IF (@V_IDSALDEMPR = 'M') BEGIN
        SELECT @DATA_SALDO = MAX(DTDATA)
          FROM DATA
         WHERE DTMES = '01/' + SUBSTRING(CONVERT(VARCHAR, @DATA_SALDO, 103), 04, 07);
     END;

     WHILE (@DATA_SALDO <= @V_DTFINACONT) BEGIN
        INSERT INTO  SALDEMPR
           (CDEMPRESA, CDCONTCTBL, DTSALDEMPR, VRSALDEMPR)
           (SELECT @P_CDEMPRESA, C.CDCONTCTBL, @DATA_SALDO, '0'
              FROM CONTCTBL C
             WHERE (C.CDCONTCTBL NOT IN (SELECT DISTINCT CDCONTCTBL
                                           FROM SALDEMPR
                                          WHERE ((CDEMPRESA = @P_CDEMPRESA)
                                            AND (DTSALDEMPR = @DATA_SALDO))))
               AND (CHARINDEX(RTRIM(C.CDCONTCTBL), @C_SALDANT_CDCONTCTBL) = 1));

        IF (@V_IDSALDEMPR = 'M') BEGIN
           SET @DATA_SALDO = DATEADD(MM, 1, @DATA_SALDO);

           SELECT @DATA_SALDO = MAX(DTDATA)
             FROM DATA
            WHERE DTMES = '01/' + SUBSTRING(CONVERT(VARCHAR,@DATA_SALDO, 103), 04, 07);
        END
        ELSE BEGIN
           SET @DATA_SALDO = @DATA_SALDO + 1;
        END;
	  END;

     UPDATE SALDEMPR
        SET VRSALDEMPR = @C_SALDANT_VRSALDEMPR
      WHERE (SALDEMPR.CDEMPRESA  =  @P_CDEMPRESA)
        AND (SALDEMPR.DTSALDEMPR >= @P_DATAINIC)
        AND (SALDEMPR.CDCONTCTBL =  @C_SALDANT_CDCONTCTBL);

     FETCH NEXT FROM C_SALDANT INTO @C_SALDANT_CDCONTCTBL, @C_SALDANT_DTSALDEMPR, @C_SALDANT_VRSALDEMPR;
  END;
  CLOSE C_SALDANT;
  DEALLOCATE C_SALDANT;

/* ATUALIZA SALDO CONTBIL */

  DECLARE C_ATUALIZA CURSOR FOR
     SELECT LANCCONT.CDCONTCTBL, MIN(DTLANCCONT) AS MENOR_DATA
       FROM LANCCONT, CONTCTBL
      WHERE (LANCCONT.CDEMPRESA  =  @P_CDEMPRESA)
        AND (LANCCONT.DTLANCCONT >= @P_DATAINIC)
        AND (LANCCONT.CDCONTCTBL BETWEEN @V_CDCONTINI AND @V_CDCONTFIM)
        AND (LANCCONT.CDCONTCTBL = CONTCTBL.CDCONTCTBL)
        AND (CONTCTBL.IDCONTCCUS <> 'R')
      GROUP BY LANCCONT.CDCONTCTBL;

  OPEN C_ATUALIZA;
  FETCH NEXT FROM C_ATUALIZA INTO @C_ATUALIZA_CDCONTCTBL, @C_ATUALIZA_MENOR_DATA;

  WHILE (@@FETCH_STATUS = 0) BEGIN
     SET @DATA_SALDO = @C_ATUALIZA_MENOR_DATA;

	  IF (@V_IDSALDEMPR = 'M') BEGIN
        SELECT @DATA_SALDO = MAX(DTDATA)
          FROM DATA
         WHERE DTMES = '01/' + SUBSTRING(CONVERT(VARCHAR, @DATA_SALDO, 103), 04, 07);
     END;

     SELECT @V_CONTSALDO = COUNT(*)
       FROM SALDEMPR S
      WHERE (S.CDEMPRESA  = @P_CDEMPRESA)
        AND (S.CDCONTCTBL = @C_ATUALIZA_CDCONTCTBL)
        AND (S.DTSALDEMPR = @DATA_SALDO);

	  IF (@V_CONTSALDO = 0) BEGIN
        WHILE (@DATA_SALDO <= @V_DTFINACONT) BEGIN
           INSERT INTO SALDEMPR
              (CDEMPRESA, CDCONTCTBL, DTSALDEMPR, VRSALDEMPR)
	           (SELECT @P_CDEMPRESA, CDCONTCTBL, @DATA_SALDO, '0'
                 FROM CONTCTBL
                WHERE (CDCONTCTBL NOT IN (SELECT DISTINCT CDCONTCTBL
                                            FROM SALDEMPR
                                           WHERE ((CDEMPRESA = @P_CDEMPRESA)
                                             AND (DTSALDEMPR = @DATA_SALDO))))
                  AND (CHARINDEX(RTRIM(CONTCTBL.CDCONTCTBL), @C_ATUALIZA_CDCONTCTBL) = 1));

           IF (@V_IDSALDEMPR = 'M') BEGIN
              SET @DATA_SALDO = DATEADD(MM, 1, @DATA_SALDO);

              SELECT @DATA_SALDO = MAX(DTDATA)
                FROM DATA
               WHERE DTMES = '01/' + SUBSTRING(CONVERT(VARCHAR, @DATA_SALDO, 103), 04, 07);
           END
           ELSE BEGIN
              SET @DATA_SALDO = @DATA_SALDO + 1;
           END;
        END;
     END;

	  SET @DATA_SALDO = @C_ATUALIZA_MENOR_DATA;

	  IF (@V_IDSALDEMPR = 'M') BEGIN
        SELECT @DATA_SALDO = MAX(DTDATA)
          FROM DATA
         WHERE DTMES = '01/' + SUBSTRING(CONVERT(VARCHAR,@DATA_SALDO, 103), 04, 07);
     END;

     WHILE (@DATA_SALDO <= @V_DTFINACONT) BEGIN
        DECLARE C_SOMACONTA CURSOR FOR
           SELECT CDCONTCTBL, SUM(ROUND(LANCCONT.VRLANCAMENT,2)) AS VALORSALDO
             FROM LANCCONT
            WHERE (LANCCONT.DTLANCCONT BETWEEN @C_ATUALIZA_MENOR_DATA AND @DATA_SALDO)
              AND (LANCCONT.CDCONTCTBL = @C_ATUALIZA_CDCONTCTBL)
              AND (LANCCONT.CDEMPRESA  = @P_CDEMPRESA)
            GROUP BY LANCCONT.CDCONTCTBL;

        OPEN C_SOMACONTA;
        FETCH NEXT FROM C_SOMACONTA INTO @C_SOMACONTA_CDCONTCTBL, @C_SOMACONTA_VALORSALDO;

        WHILE (@@FETCH_STATUS = 0) BEGIN
           UPDATE SALDEMPR
              SET VRSALDEMPR = SALDEMPR.VRSALDEMPR + @C_SOMACONTA_VALORSALDO
            WHERE (SALDEMPR.CDEMPRESA  = @P_CDEMPRESA)
              AND (SALDEMPR.DTSALDEMPR = @DATA_SALDO)
              AND (CHARINDEX(RTRIM(SALDEMPR.CDCONTCTBL), @C_SOMACONTA_CDCONTCTBL) = 1);

           FETCH NEXT FROM C_SOMACONTA INTO @C_SOMACONTA_CDCONTCTBL, @C_SOMACONTA_VALORSALDO;
        END;
        CLOSE C_SOMACONTA;
        DEALLOCATE C_SOMACONTA;

        IF (@V_IDSALDEMPR = 'M') BEGIN
           SET @DATA_SALDO = DATEADD(MM, 1, @DATA_SALDO);

           SELECT @DATA_SALDO = MAX(DTDATA)
             FROM DATA
            WHERE DTMES = '01/' + SUBSTRING(CONVERT(VARCHAR,@DATA_SALDO, 103), 04, 07);
        END
        ELSE BEGIN
           SET @DATA_SALDO = @DATA_SALDO + 1;
        END;
     END; /* WHILE */

     FETCH NEXT FROM C_ATUALIZA INTO @C_ATUALIZA_CDCONTCTBL, @C_ATUALIZA_MENOR_DATA;
  END;
  CLOSE C_ATUALIZA;
  DEALLOCATE C_ATUALIZA;

  /********************************************************************************/
  /* ROTINA PARA ATUALIZAR OS SALDOS DAS CONTAS SEM CONSIDERAR AS TRANSFERNCIAS  */
  /********************************************************************************/

  DECLARE C_SALDO CURSOR FOR
     SELECT L.CDCONTCTBL, D.DTLANCCONT
       FROM LANCCONT L, (SELECT MAX(DTDATA) DTLANCCONT
                           FROM DATA
                          WHERE DTMES BETWEEN @P_DATAINIC AND @V_DTFINACONT
                          GROUP BY SUBSTRING(CONVERT(VARCHAR, DTDATA, 103), 4, 7)) D
      WHERE L.CDEMPRESA  = @P_CDEMPRESA
        AND L.IDLANCINTE = 'T'
        AND SUBSTRING(CONVERT(VARCHAR, L.DTLANCCONT, 103), 4, 7) = SUBSTRING(CONVERT(VARCHAR, D.DTLANCCONT, 103), 4, 7)
        AND L.CDCONTCTBL BETWEEN @V_CDCONTINI AND @V_CDCONTFIM
     GROUP BY L.CDCONTCTBL, D.DTLANCCONT
     ORDER BY D.DTLANCCONT, CDCONTCTBL;
     OPEN C_SALDO;
     FETCH NEXT FROM C_SALDO INTO @C_SALDO_CDCONTCTBL, @C_SALDO_DTLANCCONT;

     WHILE @@FETCH_STATUS = 0 BEGIN
        SELECT @V_VRSALDO = ISNULL(SUM(VRLANCAMENT),0)
          FROM LANCCONT
         WHERE CDEMPRESA  = @P_CDEMPRESA
           AND IDLANCINTE <> 'T'
           AND CDCONTCTBL = @C_SALDO_CDCONTCTBL
           AND DTLANCCONT BETWEEN CONVERT(DATETIME, '01/' + SUBSTRING(CONVERT(VARCHAR, @C_SALDO_DTLANCCONT, 103), 4, 7)) AND @C_SALDO_DTLANCCONT;


        SET @V_DATA_SALDO = CONVERT(DATETIME, '01/' + SUBSTRING(CONVERT(VARCHAR, @C_SALDO_DTLANCCONT, 103), 4, 7));

        SELECT @V_VRSALDEMPR = ISNULL(SA.VRSALDEMPR, 0)
          FROM SALDEMPR SA
         WHERE SA.CDEMPRESA  = @P_CDEMPRESA
           AND SA.CDCONTCTBL = @C_SALDO_CDCONTCTBL
           AND SA.DTSALDEMPR IN (SELECT MAX(DTDATA)
                                   FROM DATA
                                  WHERE SUBSTRING(CONVERT(VARCHAR, DTDATA, 103), 4, 7) = SUBSTRING(CONVERT(VARCHAR,  DATEADD(MM, -1, @V_DATA_SALDO), 103), 4, 7));

        SET @V_VRSALDO = ISNULL(@V_VRSALDO , 0) + ISNULL(@V_VRSALDEMPR, 0);

        IF @V_VRSALDO <> 0 BEGIN
           INSERT INTO SALDOTRANSF
             (CDEMPRESA, CDCONTCTBL, DTSALDOTRANSF, VRSALDOTRANSF)
           VALUES
             (@P_CDEMPRESA, @C_SALDO_CDCONTCTBL, @C_SALDO_DTLANCCONT, ISNULL(@V_VRSALDO, 0));
        END;
        FETCH NEXT FROM C_SALDO INTO @C_SALDO_CDCONTCTBL, @C_SALDO_DTLANCCONT;
     END;
     CLOSE C_SALDO;
     DEALLOCATE C_SALDO;

     DECLARE C_ATUALIZAT CURSOR FOR
        SELECT DISTINCT LANCCONT.CDCONTCTBL, D.DTLANCCONT
          FROM LANCCONT, CONTCTBL, (SELECT MAX(DTDATA) DTLANCCONT
                                      FROM DATA
                                     WHERE DTMES >= @P_DATAINIC
                                     GROUP BY SUBSTRING(CONVERT(VARCHAR, DTDATA, 103), 4, 7)) D
         WHERE (LANCCONT.CDEMPRESA   = @P_CDEMPRESA)
           AND SUBSTRING(CONVERT(VARCHAR, LANCCONT.DTLANCCONT, 103), 4, 7) = SUBSTRING(CONVERT(VARCHAR, D.DTLANCCONT, 103), 4, 7)
           AND (LANCCONT.CDCONTCTBL BETWEEN @V_CDCONTINI AND @V_CDCONTFIM)
           AND (LANCCONT.CDCONTCTBL = CONTCTBL.CDCONTCTBL)
           AND (CONTCTBL.IDCONTCCUS <> 'R')
           AND (LANCCONT.IDLANCINTE = 'T')
         GROUP BY D.DTLANCCONT, LANCCONT.CDCONTCTBL
         ORDER BY D.DTLANCCONT, LANCCONT.CDCONTCTBL;

        OPEN C_ATUALIZAT;
        FETCH NEXT FROM C_ATUALIZAT INTO @C_ATUALIZAT_CDCONTCTBL, @C_ATUALIZAT_DTLANCCONT;
        WHILE @@FETCH_STATUS = 0 BEGIN
           SELECT @V_VRSALDO = ISNULL(SUM(VRLANCAMENT), 0)
             FROM LANCCONT
            WHERE SUBSTRING(CONVERT(VARCHAR, DTLANCCONT, 103), 4, 7) = SUBSTRING(CONVERT(VARCHAR, @C_ATUALIZAT_DTLANCCONT, 103), 4, 7)
              AND CDEMPRESA  = @P_CDEMPRESA
              AND CDCONTCTBL = @C_ATUALIZAT_CDCONTCTBL
              AND IDLANCINTE <> 'T';

           SELECT @V_MENOR_DATA = MIN(DTLANCCONT)
             FROM LANCCONT
            WHERE (LANCCONT.CDEMPRESA   = @P_CDEMPRESA)
              AND (LANCCONT.DTLANCCONT >= @P_DATAINIC)
              AND (LANCCONT.CDCONTCTBL  = @C_ATUALIZAT_CDCONTCTBL);

           IF @V_VRSALDO <> 0 BEGIN
              SELECT @V_DATA_SALDO = CONVERT(VARCHAR, MAX(DTDATA), 103)
                FROM DATA
               WHERE SUBSTRING(CONVERT(VARCHAR, DTDATA, 103), 4, 7) = SUBSTRING(CONVERT(VARCHAR, @V_MENOR_DATA, 103), 4, 7);

              WHILE (@V_DATA_SALDO <= @V_DTFINACONT) BEGIN

                 INSERT INTO SALDOTRANSF
                    (CDEMPRESA, CDCONTCTBL, DTSALDOTRANSF, VRSALDOTRANSF)
   	              (SELECT @P_CDEMPRESA, CDCONTCTBL, @V_DATA_SALDO, @V_VRSALDO
                       FROM CONTCTBL
                      WHERE (CDCONTCTBL NOT IN (SELECT DISTINCT CDCONTCTBL
                                                  FROM SALDOTRANSF
                                                 WHERE ((CDEMPRESA    = @P_CDEMPRESA)
                                                   AND (DTSALDOTRANSF = @V_DATA_SALDO))))
                        AND (CHARINDEX(RTRIM(CONTCTBL.CDCONTCTBL), @C_ATUALIZAT_CDCONTCTBL) = 1));

                 SELECT @V_DATA_SALDO = CONVERT(VARCHAR, MAX(DTDATA), 103)
                   FROM DATA
                  WHERE SUBSTRING(CONVERT(VARCHAR, DTDATA, 103), 4, 7) = SUBSTRING(CONVERT(VARCHAR,  DATEADD(MM, 1, @V_DATA_SALDO), 103), 4, 7);
              END;
           END;
        FETCH NEXT FROM C_ATUALIZAT INTO @C_ATUALIZAT_CDCONTCTBL, @C_ATUALIZAT_DTLANCCONT;
     END;
     CLOSE C_ATUALIZAT;
     DEALLOCATE C_ATUALIZAT;

     /* ATUALIZA OS VALORES DE TRANSFERNCIA PARA CONTAS CONTBEIS SINTTICAS */
     /* TRAZ OS VALORES DAS CONTAS CONTBEIS E AS PRPRIAS CONTAS A PARTIR DA DATA INICIAL */
     DECLARE C_SALDO_SINTETICO CURSOR FOR
        SELECT VRSALDOTRANSF, DTSALDOTRANSF, S.CDCONTCTBL
          FROM SALDOTRANSF S, CONTCTBL C
         WHERE S.CDEMPRESA = @P_CDEMPRESA
           AND S.DTSALDOTRANSF >= @P_DATAINIC
           AND S.CDCONTCTBL BETWEEN @V_CDCONTINI AND @V_CDCONTFIM
           AND S.CDCONTCTBL = C.CDCONTCTBL
           AND C.IDTIPOCONT = 'S';
        OPEN C_SALDO_SINTETICO;
        FETCH  NEXT FROM C_SALDO_SINTETICO INTO @C_SALDO_SINTETICO_VRSALDOTRANSF, @C_SALDO_SINTETICO_DTSALDOTRANSF, @C_SALDO_SINTETICO_CDCONTCTBL;
        WHILE @@FETCH_STATUS = 0 BEGIN

           SELECT @V_DATA_SALDO = CONVERT(VARCHAR, MAX(DTDATA), 103)
             FROM DATA
            WHERE SUBSTRING(CONVERT(VARCHAR, DTDATA, 103), 4, 7) = SUBSTRING(CONVERT(VARCHAR, @C_SALDO_SINTETICO_DTSALDOTRANSF, 103), 4, 7)

           /*TRAZ OS SALDOS DOS MESES ANTERIORES S TRANSFERNCIAS */
           WHILE (@V_DATA_SALDO <= @V_DTFINACONT) BEGIN
              SELECT @V_VRSALDEMPR = ISNULL(VRSALDEMPR, 0)
                FROM SALDEMPR S
               WHERE S.CDEMPRESA  = @P_CDEMPRESA
                 AND S.CDCONTCTBL = @C_SALDO_SINTETICO_CDCONTCTBL
                 AND S.DTSALDEMPR =   (SELECT  MAX(DTDATA)
                                         FROM DATA
                                        WHERE SUBSTRING(CONVERT(VARCHAR, DTDATA, 103), 4, 7) = SUBSTRING(CONVERT(VARCHAR,  DATEADD(MM, -1, @C_SALDO_SINTETICO_DTSALDOTRANSF), 103), 4, 7));

              SELECT @V_VRSALDO = ISNULL(SUM(VRLANCAMENT), 0)
                FROM LANCCONT L, CONTCTBL C
               WHERE L.CDEMPRESA  = @P_CDEMPRESA
                 AND L.CDCONTCTBL LIKE @C_SALDO_SINTETICO_CDCONTCTBL + '%'
                 AND SUBSTRING(CONVERT(VARCHAR, L.DTLANCCONT, 103), 4, 7) = SUBSTRING(CONVERT(VARCHAR, @C_SALDO_SINTETICO_DTSALDOTRANSF, 103), 4, 7)
                 AND L.CDCONTCTBL = C.CDCONTCTBL
                 AND L.IDLANCINTE <> 'T'
                 AND C.IDTIPOCONT = 'A';


                /* ATUALIZA O SALDO DA CONTA SOMANDO O VALOR ANTERIOR DA SALDEMPR MAIS
                 OS VALORES DOS LANAMENTOS DO MS, ESTES VALORES J ESTO GRAVADOS NA TABELA */
              UPDATE SALDOTRANSF
                 SET VRSALDOTRANSF = @V_VRSALDEMPR + @V_VRSALDO
               WHERE DTSALDOTRANSF = @V_DATA_SALDO
                 AND CDEMPRESA     = @P_CDEMPRESA
                 AND CDCONTCTBL    = @C_SALDO_SINTETICO_CDCONTCTBL;

              SELECT @V_DATA_SALDO = CONVERT(VARCHAR, MAX(DTDATA), 103)
                FROM DATA
               WHERE SUBSTRING(CONVERT(VARCHAR, DTDATA, 103), 4, 7) = SUBSTRING(CONVERT(VARCHAR,  DATEADD(MM, 1, @V_DATA_SALDO), 103), 4, 7);
           END;
           FETCH  NEXT FROM C_SALDO_SINTETICO INTO @C_SALDO_SINTETICO_VRSALDOTRANSF, @C_SALDO_SINTETICO_DTSALDOTRANSF, @C_SALDO_SINTETICO_CDCONTCTBL;
        END;
        CLOSE C_SALDO_SINTETICO;
        DEALLOCATE C_SALDO_SINTETICO;
  UPDATE LANCCONT
     SET IDLANCSALDO  =  'S'
   WHERE (CDEMPRESA   =  @P_CDEMPRESA)
     AND (DTLANCCONT  >= @P_DATAINIC)
     AND (IDLANCSALDO =  'N');
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_SALDO_GERAL','5.45.000';
GO

